#!/usr/bin/env python2

import panda3d.core
from direct.distributed.PyDatagram import PyDatagram
from direct.distributed.PyDatagramIterator import PyDatagramIterator
from direct.showbase.ShowBase import ShowBase

class Client(ShowBase):
    def __init__(self):
        ShowBase.__init__(self)
        self.conn()

    def conn(self):
        self.manager = panda3d.core.QueuedConnectionManager()
        self.reader = panda3d.core.QueuedConnectionReader(self.manager, 0)
        self.writer = panda3d.core.ConnectionWriter(self.manager, 0)
        port = 2424
        address = 'localhost'
        timeout = 3000
        self.connection = self.manager.openTCPClientConnection(address, port, timeout)
        if self.connection:
            print dir(self.connection), self.connection.get_address()
            self.reader.addConnection(self.connection)
        self.taskMgr.add(self.tskReaderPolling, "Reader", -39)
        self.taskMgr.add(self.tskWriterPolling, "writer", -40)

    def tskReaderPolling(self, taskData):
        if self.reader.dataAvailable():
            datagram = panda3d.core.NetDatagram()
            print("Empfange Daten.")
            if self.reader.getData(datagram):
                self.process(datagram)
        return taskData.cont

    def datagram(self):
        datagram = PyDatagram()
        datagram.addUint8(1)
        datagram.addString("Frage")
        return datagram

    def process(self):
        iterator = panda3d.core.PyDatagramIterator(datagram)
        print iterator.getUint8(), iterator.getString()

    def tskWriterPolling(self, taskData):
        self.writer.send(self.datagram(), self.connection)
        print("Frage gesendet")
        return taskData.cont

if __name__ == '__main__':
    client = Client()
    client.run()