#!/usr/bin/env python2

from direct.showbase.ShowBase import ShowBase
from direct.distributed.PyDatagram import PyDatagram
from direct.distributed.PyDatagramIterator import PyDatagramIterator
import panda3d.core

class Server(ShowBase):
    def __init__(self):
        ShowBase.__init__(self)
        self.make_conn()

    def make_conn(self):
        self.manager = panda3d.core.QueuedConnectionManager()
        self.listener = panda3d.core.QueuedConnectionListener(self.manager, 0)
        self.reader = panda3d.core.QueuedConnectionReader(self.manager, 0)
        self.writer = panda3d.core.ConnectionWriter(self.manager, 0)
        self.connections = []

        port_address = 2424
        backlog = 1000
        tcpSocket = self.manager.openTCPServerRendezvous(port_address, backlog)
        
        self.taskMgr.add(self.tskListenerPolling, "Poll the connection listener" , -39)
        self.taskMgr.add(self.tskReaderPolling, "Poll the connection reader", -40)

    def tskListenerPolling(self, taskData):
        print("polling...")
        if self.listener.newConnectionAvailable():
            print("connection available")
            rendezvous = panda3d.core.PointerToConnection()
            netAddress = panda3d.core.NetAddress
            newConnection = panda3d.core.PointerToConnection()
            if self.listener.getNewConnection(rendezvous, netAddress, newConnection):
                print("Got connection!")
                newConnection = newConnection.p()
                self.connections.append(newConnection)
                self.reader.addConnection(newConnection)
        return taskData.cont

    def tskReaderPolling(self, taskData):
        if self.reader.dataAvailable():
            datagram = distributed.NetDatagram()
            if self.reader.getData(datagram):
                self.process(datagram)
        return taskData.cont
                
    def datagram(self):
        datagram = panda3d.core.PyDatagram()
        datagram.addUint8(1)
        datagram.addString("Antwort")
        return datagram

    def process(self, datagram):
        iterator = panda3d.core.PyDatagramIterator(datagram)
        print iterator.getUint8(), iterator.getString()
        self.writer.send(self.datagram(), connection)

if __name__ == '__main__':
    Server().run()